// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "FTDistribution2DVoigt.pypp.h"

namespace bp = boost::python;

struct FTDistribution2DVoigt_wrapper : FTDistribution2DVoigt, bp::wrapper< FTDistribution2DVoigt > {

    FTDistribution2DVoigt_wrapper(FTDistribution2DVoigt const & arg )
    : FTDistribution2DVoigt( arg )
      , bp::wrapper< FTDistribution2DVoigt >(){
        // copy constructor
        m_pyobj = 0;
    }

    FTDistribution2DVoigt_wrapper(double coherence_length_x, double coherence_length_y, double eta )
    : FTDistribution2DVoigt( coherence_length_x, coherence_length_y, eta )
      , bp::wrapper< FTDistribution2DVoigt >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::FTDistribution2DVoigt * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->FTDistribution2DVoigt::clone(  );
        }
    }
    
    ::FTDistribution2DVoigt * default_clone(  ) const  {
        return FTDistribution2DVoigt::clone( );
    }

    virtual double evaluate( double qx, double qy ) const  {
        if( bp::override func_evaluate = this->get_override( "evaluate" ) )
            return func_evaluate( qx, qy );
        else{
            return this->FTDistribution2DVoigt::evaluate( qx, qy );
        }
    }
    
    double default_evaluate( double qx, double qy ) const  {
        return FTDistribution2DVoigt::evaluate( qx, qy );
    }

    virtual double evaluateLattice( double qx, double qy ) const  {
        if( bp::override func_evaluateLattice = this->get_override( "evaluateLattice" ) )
            return func_evaluateLattice( qx, qy );
        else{
            return this->FTDistribution2DVoigt::evaluateLattice( qx, qy );
        }
    }
    
    double default_evaluateLattice( double qx, double qy ) const  {
        return FTDistribution2DVoigt::evaluateLattice( qx, qy );
    }

    virtual double getEta(  ) const  {
        if( bp::override func_getEta = this->get_override( "getEta" ) )
            return func_getEta(  );
        else{
            return this->FTDistribution2DVoigt::getEta(  );
        }
    }
    
    double default_getEta(  ) const  {
        return FTDistribution2DVoigt::getEta( );
    }

    PyObject* m_pyobj;

};

void register_FTDistribution2DVoigt_class(){

    { //::FTDistribution2DVoigt
        typedef bp::class_< FTDistribution2DVoigt_wrapper, bp::bases< IFTDistribution2D >, std::auto_ptr< FTDistribution2DVoigt_wrapper > > FTDistribution2DVoigt_exposer_t;
        FTDistribution2DVoigt_exposer_t FTDistribution2DVoigt_exposer = FTDistribution2DVoigt_exposer_t( "FTDistribution2DVoigt", "2 dimensional Voigt distribution in Fourier space.", bp::init< double, double, double >(( bp::arg("coherence_length_x"), bp::arg("coherence_length_y"), bp::arg("eta") )) );
        bp::scope FTDistribution2DVoigt_scope( FTDistribution2DVoigt_exposer );
        { //::FTDistribution2DVoigt::clone
        
            typedef ::FTDistribution2DVoigt * ( ::FTDistribution2DVoigt::*clone_function_type)(  ) const;
            typedef ::FTDistribution2DVoigt * ( FTDistribution2DVoigt_wrapper::*default_clone_function_type)(  ) const;
            
            FTDistribution2DVoigt_exposer.def( 
                "clone"
                , clone_function_type(&::FTDistribution2DVoigt::clone)
                , default_clone_function_type(&FTDistribution2DVoigt_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::FTDistribution2DVoigt::evaluate
        
            typedef double ( ::FTDistribution2DVoigt::*evaluate_function_type)( double,double ) const;
            typedef double ( FTDistribution2DVoigt_wrapper::*default_evaluate_function_type)( double,double ) const;
            
            FTDistribution2DVoigt_exposer.def( 
                "evaluate"
                , evaluate_function_type(&::FTDistribution2DVoigt::evaluate)
                , default_evaluate_function_type(&FTDistribution2DVoigt_wrapper::default_evaluate)
                , ( bp::arg("qx"), bp::arg("qy") ) );
        
        }
        { //::FTDistribution2DVoigt::evaluateLattice
        
            typedef double ( ::FTDistribution2DVoigt::*evaluateLattice_function_type)( double,double ) const;
            typedef double ( FTDistribution2DVoigt_wrapper::*default_evaluateLattice_function_type)( double,double ) const;
            
            FTDistribution2DVoigt_exposer.def( 
                "evaluateLattice"
                , evaluateLattice_function_type(&::FTDistribution2DVoigt::evaluateLattice)
                , default_evaluateLattice_function_type(&FTDistribution2DVoigt_wrapper::default_evaluateLattice)
                , ( bp::arg("qx"), bp::arg("qy") ) );
        
        }
        { //::FTDistribution2DVoigt::getEta
        
            typedef double ( ::FTDistribution2DVoigt::*getEta_function_type)(  ) const;
            typedef double ( FTDistribution2DVoigt_wrapper::*default_getEta_function_type)(  ) const;
            
            FTDistribution2DVoigt_exposer.def( 
                "getEta"
                , getEta_function_type(&::FTDistribution2DVoigt::getEta)
                , default_getEta_function_type(&FTDistribution2DVoigt_wrapper::default_getEta) );
        
        }
    }

}
