// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "FormFactorHemiEllipsoid.pypp.h"

namespace bp = boost::python;

struct FormFactorHemiEllipsoid_wrapper : FormFactorHemiEllipsoid, bp::wrapper< FormFactorHemiEllipsoid > {

    FormFactorHemiEllipsoid_wrapper(double radius_x, double radius_y, double height )
    : FormFactorHemiEllipsoid( radius_x, radius_y, height )
      , bp::wrapper< FormFactorHemiEllipsoid >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::FormFactorHemiEllipsoid * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->FormFactorHemiEllipsoid::clone(  );
        }
    }
    
    ::FormFactorHemiEllipsoid * default_clone(  ) const  {
        return FormFactorHemiEllipsoid::clone( );
    }

    virtual ::complex_t evaluate_for_q( ::cvector_t const & q ) const  {
        if( bp::override func_evaluate_for_q = this->get_override( "evaluate_for_q" ) )
            return func_evaluate_for_q( boost::ref(q) );
        else{
            return this->FormFactorHemiEllipsoid::evaluate_for_q( boost::ref(q) );
        }
    }
    
    ::complex_t default_evaluate_for_q( ::cvector_t const & q ) const  {
        return FormFactorHemiEllipsoid::evaluate_for_q( boost::ref(q) );
    }

    virtual double getHeight(  ) const  {
        if( bp::override func_getHeight = this->get_override( "getHeight" ) )
            return func_getHeight(  );
        else{
            return this->FormFactorHemiEllipsoid::getHeight(  );
        }
    }
    
    double default_getHeight(  ) const  {
        return FormFactorHemiEllipsoid::getHeight( );
    }

    virtual double getRadiusX(  ) const  {
        if( bp::override func_getRadiusX = this->get_override( "getRadiusX" ) )
            return func_getRadiusX(  );
        else{
            return this->FormFactorHemiEllipsoid::getRadiusX(  );
        }
    }
    
    double default_getRadiusX(  ) const  {
        return FormFactorHemiEllipsoid::getRadiusX( );
    }

    virtual double getRadiusY(  ) const  {
        if( bp::override func_getRadiusY = this->get_override( "getRadiusY" ) )
            return func_getRadiusY(  );
        else{
            return this->FormFactorHemiEllipsoid::getRadiusY(  );
        }
    }
    
    double default_getRadiusY(  ) const  {
        return FormFactorHemiEllipsoid::getRadiusY( );
    }

    virtual ::ISample * cloneInvertB(  ) const  {
        if( bp::override func_cloneInvertB = this->get_override( "cloneInvertB" ) )
            return func_cloneInvertB(  );
        else{
            return this->ISample::cloneInvertB(  );
        }
    }
    
    ::ISample * default_cloneInvertB(  ) const  {
        return ISample::cloneInvertB( );
    }

    virtual bool containsMagneticMaterial(  ) const  {
        if( bp::override func_containsMagneticMaterial = this->get_override( "containsMagneticMaterial" ) )
            return func_containsMagneticMaterial(  );
        else{
            return this->ISample::containsMagneticMaterial(  );
        }
    }
    
    bool default_containsMagneticMaterial(  ) const  {
        return ISample::containsMagneticMaterial( );
    }

    virtual ::complex_t evaluate( ::WavevectorInfo const & wavevectors ) const  {
        if( bp::override func_evaluate = this->get_override( "evaluate" ) )
            return func_evaluate( boost::ref(wavevectors) );
        else{
            return this->IFormFactorBorn::evaluate( boost::ref(wavevectors) );
        }
    }
    
    ::complex_t default_evaluate( ::WavevectorInfo const & wavevectors ) const  {
        return IFormFactorBorn::evaluate( boost::ref(wavevectors) );
    }

    virtual ::std::vector< const ISample* > getChildren(  ) const  {
        if( bp::override func_getChildren = this->get_override( "getChildren" ) )
            return func_getChildren(  );
        else{
            return this->ISample::getChildren(  );
        }
    }
    
    ::std::vector< const ISample* > default_getChildren(  ) const  {
        return ISample::getChildren( );
    }

    virtual double getRadius(  ) const  {
        if( bp::override func_getRadius = this->get_override( "getRadius" ) )
            return func_getRadius(  );
        else{
            return this->IFormFactor::getRadius(  );
        }
    }
    
    double default_getRadius(  ) const  {
        return IFormFactor::getRadius( );
    }

    virtual double getVolume(  ) const  {
        if( bp::override func_getVolume = this->get_override( "getVolume" ) )
            return func_getVolume(  );
        else{
            return this->IFormFactorBorn::getVolume(  );
        }
    }
    
    double default_getVolume(  ) const  {
        return IFormFactorBorn::getVolume( );
    }

    virtual void printSampleTree(  ) {
        if( bp::override func_printSampleTree = this->get_override( "printSampleTree" ) )
            func_printSampleTree(  );
        else{
            this->ISample::printSampleTree(  );
        }
    }
    
    void default_printSampleTree(  ) {
        ISample::printSampleTree( );
    }

    virtual void setAmbientMaterial( ::IMaterial const & material ) {
        if( bp::override func_setAmbientMaterial = this->get_override( "setAmbientMaterial" ) )
            func_setAmbientMaterial( boost::ref(material) );
        else{
            this->IFormFactor::setAmbientMaterial( boost::ref(material) );
        }
    }
    
    void default_setAmbientMaterial( ::IMaterial const & material ) {
        IFormFactor::setAmbientMaterial( boost::ref(material) );
    }

    virtual ::std::size_t size(  ) const  {
        if( bp::override func_size = this->get_override( "size" ) )
            return func_size(  );
        else{
            return this->ISample::size(  );
        }
    }
    
    ::std::size_t default_size(  ) const  {
        return ISample::size( );
    }

    virtual void transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        if( bp::override func_transferToCPP = this->get_override( "transferToCPP" ) )
            func_transferToCPP(  );
        else{
            this->ICloneable::transferToCPP(  );
        }
    }
    
    void default_transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        ICloneable::transferToCPP( );
    }

    PyObject* m_pyobj;

};

void register_FormFactorHemiEllipsoid_class(){

    { //::FormFactorHemiEllipsoid
        typedef bp::class_< FormFactorHemiEllipsoid_wrapper, bp::bases< IFormFactorBorn >, std::auto_ptr< FormFactorHemiEllipsoid_wrapper >, boost::noncopyable > FormFactorHemiEllipsoid_exposer_t;
        FormFactorHemiEllipsoid_exposer_t FormFactorHemiEllipsoid_exposer = FormFactorHemiEllipsoid_exposer_t( "FormFactorHemiEllipsoid", "The formfactor of an hemi ellipsoid.", bp::init< double, double, double >(( bp::arg("radius_x"), bp::arg("radius_y"), bp::arg("height") ), "Hemi Ellipsoid constructor.\n\n:Parameters:\n  - 'radius_x' - half length of one horizontal main axes\n  - 'radius_y' - half length of the other horizontal main axes\n  - 'height' - of Hemi Ellipsoid\n") );
        bp::scope FormFactorHemiEllipsoid_scope( FormFactorHemiEllipsoid_exposer );
        { //::FormFactorHemiEllipsoid::clone
        
            typedef ::FormFactorHemiEllipsoid * ( ::FormFactorHemiEllipsoid::*clone_function_type)(  ) const;
            typedef ::FormFactorHemiEllipsoid * ( FormFactorHemiEllipsoid_wrapper::*default_clone_function_type)(  ) const;
            
            FormFactorHemiEllipsoid_exposer.def( 
                "clone"
                , clone_function_type(&::FormFactorHemiEllipsoid::clone)
                , default_clone_function_type(&FormFactorHemiEllipsoid_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::FormFactorHemiEllipsoid::evaluate_for_q
        
            typedef ::complex_t ( ::FormFactorHemiEllipsoid::*evaluate_for_q_function_type)( ::cvector_t const & ) const;
            typedef ::complex_t ( FormFactorHemiEllipsoid_wrapper::*default_evaluate_for_q_function_type)( ::cvector_t const & ) const;
            
            FormFactorHemiEllipsoid_exposer.def( 
                "evaluate_for_q"
                , evaluate_for_q_function_type(&::FormFactorHemiEllipsoid::evaluate_for_q)
                , default_evaluate_for_q_function_type(&FormFactorHemiEllipsoid_wrapper::default_evaluate_for_q)
                , ( bp::arg("q") ) );
        
        }
        { //::FormFactorHemiEllipsoid::getHeight
        
            typedef double ( ::FormFactorHemiEllipsoid::*getHeight_function_type)(  ) const;
            typedef double ( FormFactorHemiEllipsoid_wrapper::*default_getHeight_function_type)(  ) const;
            
            FormFactorHemiEllipsoid_exposer.def( 
                "getHeight"
                , getHeight_function_type(&::FormFactorHemiEllipsoid::getHeight)
                , default_getHeight_function_type(&FormFactorHemiEllipsoid_wrapper::default_getHeight) );
        
        }
        { //::FormFactorHemiEllipsoid::getRadiusX
        
            typedef double ( ::FormFactorHemiEllipsoid::*getRadiusX_function_type)(  ) const;
            typedef double ( FormFactorHemiEllipsoid_wrapper::*default_getRadiusX_function_type)(  ) const;
            
            FormFactorHemiEllipsoid_exposer.def( 
                "getRadiusX"
                , getRadiusX_function_type(&::FormFactorHemiEllipsoid::getRadiusX)
                , default_getRadiusX_function_type(&FormFactorHemiEllipsoid_wrapper::default_getRadiusX) );
        
        }
        { //::FormFactorHemiEllipsoid::getRadiusY
        
            typedef double ( ::FormFactorHemiEllipsoid::*getRadiusY_function_type)(  ) const;
            typedef double ( FormFactorHemiEllipsoid_wrapper::*default_getRadiusY_function_type)(  ) const;
            
            FormFactorHemiEllipsoid_exposer.def( 
                "getRadiusY"
                , getRadiusY_function_type(&::FormFactorHemiEllipsoid::getRadiusY)
                , default_getRadiusY_function_type(&FormFactorHemiEllipsoid_wrapper::default_getRadiusY) );
        
        }
        { //::ISample::cloneInvertB
        
            typedef ::ISample * ( ::ISample::*cloneInvertB_function_type)(  ) const;
            typedef ::ISample * ( FormFactorHemiEllipsoid_wrapper::*default_cloneInvertB_function_type)(  ) const;
            
            FormFactorHemiEllipsoid_exposer.def( 
                "cloneInvertB"
                , cloneInvertB_function_type(&::ISample::cloneInvertB)
                , default_cloneInvertB_function_type(&FormFactorHemiEllipsoid_wrapper::default_cloneInvertB)
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::ISample::containsMagneticMaterial
        
            typedef bool ( ::ISample::*containsMagneticMaterial_function_type)(  ) const;
            typedef bool ( FormFactorHemiEllipsoid_wrapper::*default_containsMagneticMaterial_function_type)(  ) const;
            
            FormFactorHemiEllipsoid_exposer.def( 
                "containsMagneticMaterial"
                , containsMagneticMaterial_function_type(&::ISample::containsMagneticMaterial)
                , default_containsMagneticMaterial_function_type(&FormFactorHemiEllipsoid_wrapper::default_containsMagneticMaterial) );
        
        }
        { //::IFormFactorBorn::evaluate
        
            typedef ::complex_t ( ::IFormFactorBorn::*evaluate_function_type)( ::WavevectorInfo const & ) const;
            typedef ::complex_t ( FormFactorHemiEllipsoid_wrapper::*default_evaluate_function_type)( ::WavevectorInfo const & ) const;
            
            FormFactorHemiEllipsoid_exposer.def( 
                "evaluate"
                , evaluate_function_type(&::IFormFactorBorn::evaluate)
                , default_evaluate_function_type(&FormFactorHemiEllipsoid_wrapper::default_evaluate)
                , ( bp::arg("wavevectors") ) );
        
        }
        { //::ISample::getChildren
        
            typedef ::std::vector< const ISample* > ( ::ISample::*getChildren_function_type)(  ) const;
            typedef ::std::vector< const ISample* > ( FormFactorHemiEllipsoid_wrapper::*default_getChildren_function_type)(  ) const;
            
            FormFactorHemiEllipsoid_exposer.def( 
                "getChildren"
                , getChildren_function_type(&::ISample::getChildren)
                , default_getChildren_function_type(&FormFactorHemiEllipsoid_wrapper::default_getChildren) );
        
        }
        { //::IFormFactor::getRadius
        
            typedef double ( ::IFormFactor::*getRadius_function_type)(  ) const;
            typedef double ( FormFactorHemiEllipsoid_wrapper::*default_getRadius_function_type)(  ) const;
            
            FormFactorHemiEllipsoid_exposer.def( 
                "getRadius"
                , getRadius_function_type(&::IFormFactor::getRadius)
                , default_getRadius_function_type(&FormFactorHemiEllipsoid_wrapper::default_getRadius) );
        
        }
        { //::IFormFactorBorn::getVolume
        
            typedef double ( ::IFormFactorBorn::*getVolume_function_type)(  ) const;
            typedef double ( FormFactorHemiEllipsoid_wrapper::*default_getVolume_function_type)(  ) const;
            
            FormFactorHemiEllipsoid_exposer.def( 
                "getVolume"
                , getVolume_function_type(&::IFormFactorBorn::getVolume)
                , default_getVolume_function_type(&FormFactorHemiEllipsoid_wrapper::default_getVolume) );
        
        }
        { //::ISample::printSampleTree
        
            typedef void ( ::ISample::*printSampleTree_function_type)(  ) ;
            typedef void ( FormFactorHemiEllipsoid_wrapper::*default_printSampleTree_function_type)(  ) ;
            
            FormFactorHemiEllipsoid_exposer.def( 
                "printSampleTree"
                , printSampleTree_function_type(&::ISample::printSampleTree)
                , default_printSampleTree_function_type(&FormFactorHemiEllipsoid_wrapper::default_printSampleTree) );
        
        }
        { //::IFormFactor::setAmbientMaterial
        
            typedef void ( ::IFormFactor::*setAmbientMaterial_function_type)( ::IMaterial const & ) ;
            typedef void ( FormFactorHemiEllipsoid_wrapper::*default_setAmbientMaterial_function_type)( ::IMaterial const & ) ;
            
            FormFactorHemiEllipsoid_exposer.def( 
                "setAmbientMaterial"
                , setAmbientMaterial_function_type(&::IFormFactor::setAmbientMaterial)
                , default_setAmbientMaterial_function_type(&FormFactorHemiEllipsoid_wrapper::default_setAmbientMaterial)
                , ( bp::arg("material") ) );
        
        }
        { //::ISample::size
        
            typedef ::std::size_t ( ::ISample::*size_function_type)(  ) const;
            typedef ::std::size_t ( FormFactorHemiEllipsoid_wrapper::*default_size_function_type)(  ) const;
            
            FormFactorHemiEllipsoid_exposer.def( 
                "size"
                , size_function_type(&::ISample::size)
                , default_size_function_type(&FormFactorHemiEllipsoid_wrapper::default_size) );
        
        }
        { //::ICloneable::transferToCPP
        
            typedef void ( ::ICloneable::*transferToCPP_function_type)(  ) ;
            typedef void ( FormFactorHemiEllipsoid_wrapper::*default_transferToCPP_function_type)(  ) ;
            
            FormFactorHemiEllipsoid_exposer.def( 
                "transferToCPP"
                , transferToCPP_function_type(&::ICloneable::transferToCPP)
                , default_transferToCPP_function_type(&FormFactorHemiEllipsoid_wrapper::default_transferToCPP) );
        
        }
    }

}
