// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "SphericalDetector.pypp.h"

namespace bp = boost::python;

struct SphericalDetector_wrapper : SphericalDetector, bp::wrapper< SphericalDetector > {

    SphericalDetector_wrapper( )
    : SphericalDetector( )
      , bp::wrapper< SphericalDetector >(){
        // null constructor
    m_pyobj = 0;
    }

    SphericalDetector_wrapper(::SphericalDetector const & other )
    : SphericalDetector( boost::ref(other) )
      , bp::wrapper< SphericalDetector >(){
        // copy constructor
    m_pyobj = 0;
    }

    virtual ::SphericalDetector * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->SphericalDetector::clone(  );
        }
    }
    
    ::SphericalDetector * default_clone(  ) const  {
        return SphericalDetector::clone( );
    }

    PyObject* m_pyobj;

};

void register_SphericalDetector_class(){

    { //::SphericalDetector
        typedef bp::class_< SphericalDetector_wrapper, bp::bases< IDetector2D >, std::auto_ptr< SphericalDetector_wrapper > > SphericalDetector_exposer_t;
        SphericalDetector_exposer_t SphericalDetector_exposer = SphericalDetector_exposer_t( "SphericalDetector", "A spherical detector with axes and resolution function.", bp::init< >() );
        bp::scope SphericalDetector_scope( SphericalDetector_exposer );
        SphericalDetector_exposer.def( bp::init< SphericalDetector const & >(( bp::arg("other") )) );
        { //::SphericalDetector::clone
        
            typedef ::SphericalDetector * ( ::SphericalDetector::*clone_function_type)(  ) const;
            typedef ::SphericalDetector * ( SphericalDetector_wrapper::*default_clone_function_type)(  ) const;
            
            SphericalDetector_exposer.def( 
                "clone"
                , clone_function_type(&::SphericalDetector::clone)
                , default_clone_function_type(&SphericalDetector_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::SphericalDetector::operator=
        
            typedef ::SphericalDetector & ( ::SphericalDetector::*assign_function_type)( ::SphericalDetector const & ) ;
            
            SphericalDetector_exposer.def( 
                "assign"
                , assign_function_type( &::SphericalDetector::operator= )
                , ( bp::arg("other") )
                , bp::return_self< >() );
        
        }
    }

}
